Subject: Re: [RFC] Discuss about an new idea "Vsock over Virtio-net"

From: "Michael S. Tsirkin" <[email-masked]>
Date: Thu, 15 Nov 2018 02:04:52 -0500

On Thu, Nov 15, 2018 at 11:56:03AM +0800, jiangyiwen wrote:
> Hi Stefan, Michael, Jason and everyone,
> 
> Several days ago, I discussed with jason about "Vsock over Virtio-net".
> This idea has two advantages:
> First, it can use many great features of virtio-net, like batching,
> mergeable rx buffer and multiqueue, etc.
> Second, it can reduce many duplicate codes and make it easy to be
> maintained.

I'm not sure I get the motivation. Which features of
virtio net are relevant to vsock? The ones that you mention
all seem to be mostly of use to the networking stack.

> Before the implement, I want to discuss with everyone again, and
> want to know everyone's suggestions.
> 
> After the discussion, based on this point I will try to implement
> this idea, but I am not familiar with the virtio-net, that is a
> pity. :(
>
> -------------------------Simple idea------------------------------
> 
> 1. The packet layout will become as follows:
> 
> +---------------------------------+
> |        Virtio-net header        |
> |(struct virtio_net_hdr_mrg_rxbuf)|

Which fields in virtio_net_hdr_mrg_rxbuf are of interest to vsock?

> +---------------------------------+
> |          Vsock header           |
> |    (struct virtio_vsock_hdr)    |
> +---------------------------------+
> |             payload             |
> |      (until end of packet)      |
> +---------------------------------+

Thanks,
-- 
MST